var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { tagPropType, mapToCssModules } from './Shared/helper.js';

export var Context = React.createContext({});

//component - CoreUI / CMedia

var CMedia = function CMedia(props) {
  var Tag = props.tag,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      asideRight = props.asideRight,
      attributes = _objectWithoutProperties(props, ['tag', 'className', 'cssModule', 'innerRef', 'asideRight']);

  //render

  var classes = mapToCssModules(classNames(className, asideRight ? 'd-flex flex-row-reverse' : null, 'media'), cssModule);

  return React.createElement(
    Context.Provider,
    { value: {
        asideRight: asideRight
      } },
    React.createElement(Tag, _extends({}, attributes, { className: classes, ref: innerRef }))
  );
};

CMedia.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: tagPropType,
  className: PropTypes.string,
  cssModule: PropTypes.object,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  asideRight: PropTypes.bool
} : {};

CMedia.defaultProps = {
  tag: 'div'
};

export default CMedia;