var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React, { useContext } from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { tagPropType, mapToCssModules } from './Shared/helper.js';

import { Context } from './CMedia';

//component - CoreUI / CMediaAside

var CMediaAside = function CMediaAside(props) {
  var Tag = props.tag,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      asideImageProps = props.asideImageProps,
      asideVerticalPosition = props.asideVerticalPosition,
      asideRight = props.asideRight,
      addAsideMargin = props.addAsideMargin,
      attributes = _objectWithoutProperties(props, ['tag', 'className', 'cssModule', 'innerRef', 'asideImageProps', 'asideVerticalPosition', 'asideRight', 'addAsideMargin']);

  var computedAsideImageProps = function computedAsideImageProps() {
    return Object.assign({
      placeholderColor: '#777777',
      width: '64px',
      height: asideVerticalPosition === 'stretch' ? '100%' : '64px'
    }, asideImageProps || {});
  };

  var context = useContext(Context);

  if (!asideRight && context.asideRight) asideRight = true;

  //render

  var classes = mapToCssModules(classNames(className, addAsideMargin ? 'm' + (asideRight ? 'l' : 'r') + '-3' : '', 'align-self-' + asideVerticalPosition), cssModule);

  return React.createElement(Tag, _extends({}, attributes, { className: classes, ref: innerRef }));
};

CMediaAside.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: tagPropType,
  className: PropTypes.string,
  cssModule: PropTypes.object,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  asideVerticalPosition: PropTypes.string,
  asideRight: PropTypes.bool,
  asideImageProps: PropTypes.object,
  addAsideMargin: PropTypes.bool
} : {};

CMediaAside.defaultProps = {
  tag: 'div',
  asideVerticalPosition: 'start'
};

export default CMediaAside;