var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { tagPropType, mapToCssModules } from './Shared/helper.js';
import CPaginationLink from './CPaginationLink';

//component - CoreUI / CPaginationItem

var CPaginationItem = function CPaginationItem(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      custom = props.custom,
      innerRef = props.innerRef,
      active = props.active,
      disabled = props.disabled,
      linkClassName = props.linkClassName,
      linkProps = props.linkProps,
      attributes = _objectWithoutProperties(props, ['tag', 'children', 'className', 'cssModule', 'custom', 'innerRef', 'active', 'disabled', 'linkClassName', 'linkProps']);

  //render

  var classes = mapToCssModules(classNames(className, 'page-item', {
    'active': active,
    'disabled': disabled
  }), cssModule);

  var linkClasses = mapToCssModules(classNames(linkClassName), cssModule);

  if (!custom) {
    return React.createElement(
      Tag,
      _extends({}, attributes, { className: classes, ref: innerRef }),
      React.createElement(CPaginationLink, _extends({ className: linkClasses }, linkProps, { children: children }))
    );
  }

  return React.createElement(Tag, _extends({}, attributes, { className: classes, children: children, ref: innerRef }));
};

CPaginationItem.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: tagPropType,
  children: PropTypes.node,
  className: PropTypes.string,
  cssModule: PropTypes.object,
  custom: PropTypes.bool,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string]),
  active: PropTypes.bool,
  disabled: PropTypes.bool,
  linkClassName: PropTypes.string,
  linkProps: PropTypes.object
} : {};

CPaginationItem.defaultProps = {
  tag: 'li',
  active: false
};

export default CPaginationItem;