var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

//component - CoreUI / CSidebarHeader

var CSidebarHeader = function CSidebarHeader(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      innerRef = props.innerRef,
      attributes = _objectWithoutProperties(props, ['tag', 'children', 'className', 'innerRef']);

  //render

  var classes = classNames(className, 'c-sidebar-header');

  return children ? React.createElement(
    Tag,
    _extends({ className: classes }, attributes, { ref: innerRef }),
    children
  ) : null;
};

CSidebarHeader.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: PropTypes.oneOfType([PropTypes.func, PropTypes.string]),
  children: PropTypes.node,
  className: PropTypes.string,
  //
  innerRef: PropTypes.oneOfType([PropTypes.object, PropTypes.func, PropTypes.string])
} : {};

CSidebarHeader.defaultProps = {
  tag: 'div'
};

export default CSidebarHeader;