'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _helper = require('./Shared/helper.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//component - CoreUI / CCarouselControl

var CCarouselControl = function CCarouselControl(props) {
  var className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      direction = props.direction,
      onClickHandler = props.onClickHandler,
      directionText = props.directionText,
      attributes = _objectWithoutProperties(props, ['className', 'cssModule', 'innerRef', 'direction', 'onClickHandler', 'directionText']);

  var onClick = function onClick(e) {
    e.preventDefault();
    onClickHandler();
  };

  //render

  var anchorClasses = (0, _helper.mapToCssModules)((0, _classnames2.default)(className, 'carousel-control-' + direction), cssModule);

  var iconClasses = (0, _helper.mapToCssModules)((0, _classnames2.default)('carousel-control-' + direction + '-icon'), cssModule);

  var screenReaderClasses = (0, _helper.mapToCssModules)((0, _classnames2.default)('sr-only'), cssModule);

  return _react2.default.createElement(
    'a',
    _extends({}, attributes, {
      className: anchorClasses,
      role: 'button',
      tabIndex: '0',
      onClick: onClick,
      ref: innerRef
    }),
    _react2.default.createElement('span', { className: iconClasses, 'aria-hidden': 'true' }),
    _react2.default.createElement(
      'span',
      { className: screenReaderClasses },
      directionText || direction
    )
  );
};

CCarouselControl.propTypes = process.env.NODE_ENV !== "production" ? {
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  //
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func, _propTypes2.default.string]),
  direction: _propTypes2.default.oneOf(['prev', 'next']).isRequired,
  onClickHandler: _propTypes2.default.func.isRequired,
  directionText: _propTypes2.default.string
} : {};

exports.default = CCarouselControl;
module.exports = exports['default'];