'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _helper = require('./Shared/helper.js');

var _CEmbedObject = require('./CEmbedObject');

var _CEmbedObject2 = _interopRequireDefault(_CEmbedObject);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//component - CoreUI / CEmbed

var CEmbed = function CEmbed(props) {
  var Tag = props.tag,
      className = props.className,
      cssModule = props.cssModule,
      custom = props.custom,
      innerRef = props.innerRef,
      ratio = props.ratio,
      type = props.type,
      src = props.src,
      objectClassName = props.objectClassName,
      objectProps = props.objectProps,
      attributes = _objectWithoutProperties(props, ['tag', 'className', 'cssModule', 'custom', 'innerRef', 'ratio', 'type', 'src', 'objectClassName', 'objectProps']);

  //render

  var classes = (0, _helper.mapToCssModules)((0, _classnames2.default)(className, ratio ? 'embed-responsive-' + ratio : null, 'embed-responsive'), cssModule);

  var objectClasses = (0, _helper.mapToCssModules)((0, _classnames2.default)(objectClassName), cssModule);

  if (!custom) {
    return _react2.default.createElement(
      Tag,
      _extends({ className: classes }, attributes, { ref: innerRef }),
      _react2.default.createElement(_CEmbedObject2.default, _extends({}, objectProps, { className: objectClasses, type: type, src: src }))
    );
  }

  return _react2.default.createElement(Tag, _extends({ className: classes }, attributes, { ref: innerRef }));
};

CEmbed.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  custom: _propTypes2.default.bool,
  //
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func, _propTypes2.default.string]),
  ratio: _propTypes2.default.string,
  objectClassName: _propTypes2.default.string,
  objectProps: _propTypes2.default.object,
  ///
  type: _propTypes2.default.string,
  src: _propTypes2.default.string
} : {};

CEmbed.defaultProps = {
  tag: 'span',
  ratio: '16by9',
  type: 'iframe'
};

exports.default = CEmbed;
module.exports = exports['default'];