'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _helper = require('./Shared/helper.js');

var _CInputGroupText = require('./CInputGroupText');

var _CInputGroupText2 = _interopRequireDefault(_CInputGroupText);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//component - CoreUI / CInputGroupAddon

var CInputGroupAddon = function CInputGroupAddon(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      addonType = props.addonType,
      inputProps = props.inputProps,
      attributes = _objectWithoutProperties(props, ['tag', 'children', 'className', 'cssModule', 'innerRef', 'addonType', 'inputProps']);

  //render

  var classes = (0, _helper.mapToCssModules)((0, _classnames2.default)(className, 'input-group-' + addonType), cssModule);

  if (typeof children === 'string') {
    return _react2.default.createElement(
      Tag,
      _extends({}, attributes, { className: classes }),
      _react2.default.createElement(_CInputGroupText2.default, _extends({ children: children }, inputProps))
    );
  }

  return _react2.default.createElement(Tag, _extends({}, attributes, { className: classes, children: children, ref: innerRef }));
};

CInputGroupAddon.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  //
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func, _propTypes2.default.string]),
  addonType: _propTypes2.default.oneOf(['prepend', 'append']).isRequired,
  inputProps: _propTypes2.default.object
} : {};

CInputGroupAddon.defaultProps = {
  tag: 'div'
};

exports.default = CInputGroupAddon;
module.exports = exports['default'];