'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _helper = require('./Shared/helper.js');

var _reactRouterDom = require('react-router-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//component - CoreUI / CLink

var CLink = function CLink(props) {
  var className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      active = props.active,
      disabled = props.disabled,
      href = props.href,
      to = props.to,
      attributes = _objectWithoutProperties(props, ['className', 'cssModule', 'innerRef', 'active', 'disabled', 'href', 'to']);

  var href2 = href;

  var onClick = function onClick(e) {
    if (props.disabled) {
      e.preventDefault();
      return;
    }
    if (href2 === '#') {
      e.preventDefault();
    }
    if (props.onClick) {
      props.onClick(e);
    }
  };

  // render

  var classes = (0, _helper.mapToCssModules)((0, _classnames2.default)(className, active ? 'active' : null, disabled ? 'disabled' : null), cssModule);

  //<span {...attributes} className={classes} ref={innerRef} />

  to || href2 || (href2 = '#');

  return to ? _react2.default.createElement(_reactRouterDom.Link, _extends({ to: to }, attributes, { className: classes, ref: innerRef })) : _react2.default.createElement('a', _extends({ href: href2 }, attributes, { className: classes, onClick: onClick, ref: innerRef }));
};

CLink.propTypes = process.env.NODE_ENV !== "production" ? {
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  //
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func, _propTypes2.default.string]),
  active: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  href: _propTypes2.default.string,
  to: _propTypes2.default.string
} : {};

CLink.defaultProps = {};

exports.default = CLink;
module.exports = exports['default'];