'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _helper = require('./Shared/helper.js');

var _CNavLink = require('./CNavLink');

var _CNavLink2 = _interopRequireDefault(_CNavLink);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//component - CoreUI / CNavItem

var CNavItem = function CNavItem(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      custom = props.custom,
      innerRef = props.innerRef,
      active = props.active,
      linkClassName = props.linkClassName,
      linkProps = props.linkProps,
      to = props.to,
      href = props.href,
      attributes = _objectWithoutProperties(props, ['tag', 'children', 'className', 'cssModule', 'custom', 'innerRef', 'active', 'linkClassName', 'linkProps', 'to', 'href']);

  //render

  var classes = (0, _helper.mapToCssModules)((0, _classnames2.default)(className, 'nav-item', active ? 'active' : false), cssModule);

  var linkClasses = (0, _helper.mapToCssModules)((0, _classnames2.default)(linkClassName), cssModule);

  if (!custom) {
    return _react2.default.createElement(
      Tag,
      _extends({}, attributes, { className: classes, ref: innerRef }),
      _react2.default.createElement(_CNavLink2.default, _extends({}, linkProps, { className: linkClasses, to: to, href: href, children: children }))
    );
  }

  return _react2.default.createElement(Tag, _extends({}, attributes, { className: classes, ref: innerRef, children: children }));
};

CNavItem.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  //
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func, _propTypes2.default.string]),
  active: _propTypes2.default.bool,
  custom: _propTypes2.default.bool,
  linkClassName: _propTypes2.default.string,
  linkProps: _propTypes2.default.object,
  to: _propTypes2.default.string,
  href: _propTypes2.default.string
} : {};

CNavItem.defaultProps = {
  tag: 'li'
};

exports.default = CNavItem;
module.exports = exports['default'];