'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _helper = require('./Shared/helper.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//component - CoreUI / CSpinner

var CSpinner = function CSpinner(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      innerRef = props.innerRef,
      variant = props.variant,
      size = props.size,
      color = props.color,
      attributes = _objectWithoutProperties(props, ['tag', 'children', 'className', 'cssModule', 'innerRef', 'variant', 'size', 'color']);

  //render

  var classes = (0, _helper.mapToCssModules)((0, _classnames2.default)(className, 'spinner-' + variant, size ? 'spinner-' + variant + '-' + size : false, color ? 'text-' + color : false), cssModule);

  return _react2.default.createElement(
    Tag,
    _extends({}, attributes, { className: classes, role: 'status', ref: innerRef }),
    children && _react2.default.createElement(
      'span',
      { className: (0, _helper.mapToCssModules)('sr-only', cssModule) },
      children
    )
  );
};

CSpinner.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  children: _propTypes2.default.string,
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  //
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.func, _propTypes2.default.string]),
  variant: _propTypes2.default.string,
  size: _propTypes2.default.string,
  color: _propTypes2.default.string
} : {};

CSpinner.defaultProps = {
  tag: 'div',
  variant: 'border',
  children: 'Loading...'
};

exports.default = CSpinner;
module.exports = exports['default'];