'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _helper = require('./Shared/helper.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

//import {Context} from './CDropdownCustom';

//component - CoreUI / CToggler

var CToggler = function CToggler(props) {
  var Tag = props.tag,
      children = props.children,
      className = props.className,
      cssModule = props.cssModule,
      custom = props.custom,
      innerRef = props.innerRef,
      toggle = props.toggle,
      inHeader = props.inHeader,
      inNavbar = props.inNavbar,
      attributes = _objectWithoutProperties(props, ['tag', 'children', 'className', 'cssModule', 'custom', 'innerRef', 'toggle', 'inHeader', 'inNavbar']);

  //const context = useContext(Context);

  //events


  var onClick = function onClick(e) {
    e.preventDefault();
    //if (context.toggle)
    //  context.toggle();
    if (toggle) toggle(e);
  };

  //render

  var togglerType = inNavbar ? 'c-navbar' : inHeader ? 'c-header' : null;

  var classes = (0, _helper.mapToCssModules)((0, _classnames2.default)(className, togglerType ? togglerType + '-toggler' : null), cssModule);

  if (!custom) {
    var classesTrigger = (0, _helper.mapToCssModules)((0, _classnames2.default)(togglerType ? togglerType + '-toggler-icon' : null), cssModule);
    return _react2.default.createElement(
      Tag,
      _extends({}, attributes, { className: classes, onClick: onClick }),
      _react2.default.createElement('span', { className: classesTrigger })
    );
  }

  return _react2.default.createElement(
    Tag,
    _extends({}, attributes, { className: classes, onClick: onClick, ref: innerRef }),
    children
  );
};

CToggler.propTypes = process.env.NODE_ENV !== "production" ? {
  tag: _helper.tagPropType,
  className: _propTypes2.default.string,
  cssModule: _propTypes2.default.object,
  custom: _propTypes2.default.bool,
  //
  innerRef: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.string, _propTypes2.default.object]),
  inHeader: _propTypes2.default.bool,
  inNavbar: _propTypes2.default.bool,
  type: _propTypes2.default.string,
  toggle: _propTypes2.default.func
} : {};

CToggler.defaultProps = {
  tag: 'button',
  type: 'button'
};

exports.default = CToggler;
module.exports = exports['default'];